/**
 *
 * Copyright 2004 Hiram Chirino
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 **/
package org.codehaus.activemq.itest.ejb;

import java.rmi.RemoteException;

import javax.ejb.EJBObject;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.naming.NamingException;


/**
 * Provides the Remote interface of the MessengerBean.
 *
 * @version $Revision: 1.2 $
 */
public interface MessengerObject extends EJBObject {
  public void sendMessage(String text, int reps) throws RemoteException, NamingException, JMSException;
  public int receiveMessage(long timeout, int reps) throws RemoteException, NamingException, JMSException;
  public void sendMessage(Destination dest, String text, int reps);
  public void sendMessage(Destination dest, String text) throws java.rmi.RemoteException, NamingException, JMSException;
  public String receiveMessage(Destination dest, long timeout) throws RemoteException, NamingException, JMSException;

}

