/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.config;

import org.codehaus.activemq.ActiveMQConnectionFactory;
import org.codehaus.activemq.test.JmsTopicSendReceiveWithTwoConnectionsTest;

import javax.naming.InitialContext;
import java.util.Hashtable;

/**
 * @version $Revision: 1.1 $
 */
public class BrokerXmlConfigFromJNDITest extends JmsTopicSendReceiveWithTwoConnectionsTest {
    protected ActiveMQConnectionFactory createConnectionFactory() throws Exception {
        // START SNIPPET: example

        // we could put these properties into a jndi.properties
        // on the classpath instead
        Hashtable properties = new Hashtable();
        properties.put("java.naming.factory.initial", "org.codehaus.activemq.jndi.ActiveMQInitialContextFactory");
        properties.put("useEmbeddedBroker", Boolean.TRUE);

        // configure the embedded broker using an XML config file
        // which is either a URL or a resource on the classpath
        properties.put("brokerXmlConfig", "file:src/sample-conf/bdb-example.xml");
        properties.put("brokerURL", "vm://localhost");

        InitialContext context = new InitialContext(properties);
        ActiveMQConnectionFactory connectionFactory = (ActiveMQConnectionFactory) context.lookup("ConnectionFactory");

        // END SNIPPET: example
        return connectionFactory;
    }

}
