/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.jca;

import javax.jms.Destination;
import javax.jms.TextMessage;
import java.util.Date;

/**
 * @version $Revision: 1.4 $
 */
public class JCAContainerTest extends JCAContainerTestSupport {

    public void testMessageDeliveryUsingSharedMesssageListener() throws Exception {
        TextMessage message = session.createTextMessage("Hello! " + new Date());
        Destination destination = session.createTopic("test.spring.inboundMessageA");
        producer.send(destination, message);

        System.out.println("message sent on: " + destination);

        Thread.sleep(5000);
    }

    public void testMessageDeliveryUsingPooledMesssageListener() throws Exception {
        TextMessage message = session.createTextMessage("Hello! " + new Date());
        Destination destination = session.createQueue("test.spring.inboundMessageB");
        producer.send(destination, message);

        System.out.println("message sent on: " + destination);

        Thread.sleep(2000);
    }

}
