/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.jca;

import javax.jms.MessageListener;
import javax.jms.Message;

/**
 * @version $Revision: 1.1 $
 */
public class TestBean implements MessageListener {
    private static int globalCounter = 0;

    private int counter = getNextValue();

    public void onMessage(Message message) {
        System.out.println("TestBean: " + counter + " received message: " + message);
    }

    protected static synchronized int getNextValue() {
        return ++globalCounter;
    }

}
