/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/

package org.codehaus.activemq;

import org.codehaus.activemq.message.ActiveMQMessage;

/**
 * An internal dispatcher for ActiveMQMessage types
 *
 * @see ActiveMQSession
 * @see ActiveMQMessageConsumer
 */

public interface ActiveMQMessageDispatcher {


    /**
     * Tests to see if the Message Dispatcher is a target for this message
     *
     * @param message the message to test
     * @return true if the Message Dispatcher can dispatch the message
     */
    public boolean isTarget(ActiveMQMessage message);

    /**
     * Dispatch an ActiveMQMessage
     *
     * @param message
     */
    public void dispatch(ActiveMQMessage message);
}
