/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.broker;

import javax.jms.JMSException;

import org.codehaus.activemq.message.ActiveMQDestination;
import org.codehaus.activemq.service.MessageContainerAdmin;


/**
 * Provides a admin view to a broker.  
 *
 * @version $Revision: 1.1 $
 */
public interface BrokerAdmin {
    
    void createMessageContainer(ActiveMQDestination dest) throws JMSException;
    void destoryMessageContainer(ActiveMQDestination dest)throws JMSException;
    
    MessageContainerAdmin getMessageContainerAdmin(ActiveMQDestination dest) throws JMSException;
    MessageContainerAdmin[] listMessageContainerAdmin() throws JMSException;
    
}
