/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.io;
import org.codehaus.activemq.message.*;

import javax.jms.JMSException;

/**
 * Represents a text based WireFormat such as one that uses XML packets like the
 * {@link org.codehaus.activemq.transport.xstream.XStreamWireFormat} or the
 * {@link org.codehaus.activemq.transport.jabber.JabberWireFormat}
 *
 * @version $Revision: 1.1 $
 */
public abstract class TextWireFormat extends AbstractWireFormat {

    /**
     * Converts the packet into a String
     */
    public abstract String toString(Packet packet) throws JMSException;

    /**
     * Converts the String into a Packet
     */
    public abstract Packet fromString(String text) throws JMSException;
}
