/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.management;

import javax.management.j2ee.statistics.JCAConnectionStats;
import javax.management.j2ee.statistics.TimeStatistic;

/**
 * Statistics for a JCA connection
 *
 * @version $Revision: 1.1 $
 */
public class JCAConnectionStatsImpl extends StatsImpl implements JCAConnectionStats {
    private String connectionFactory;
    private String managedConnectionFactory;
    private TimeStatistic waitTime;
    private TimeStatistic useTime;

    public JCAConnectionStatsImpl(String connectionFactory, String managedConnectionFactory, TimeStatistic waitTime, TimeStatistic useTime) {
        this.connectionFactory = connectionFactory;
        this.managedConnectionFactory = managedConnectionFactory;
        this.waitTime = waitTime;
        this.useTime = useTime;

        // lets add named stats
        addStatistic("waitTime", waitTime);
        addStatistic("useTime", useTime);
    }

    public String getConnectionFactory() {
        return connectionFactory;
    }

    public String getManagedConnectionFactory() {
        return managedConnectionFactory;
    }

    public TimeStatistic getWaitTime() {
        return waitTime;
    }

    public TimeStatistic getUseTime() {
        return useTime;
    }

}
