/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.management;

import javax.management.j2ee.statistics.JCAConnectionPoolStats;
import javax.management.j2ee.statistics.JCAConnectionStats;
import javax.management.j2ee.statistics.JCAStats;

/**
 * Statistics for a number of JCA connections and connection pools
 *
 * @version $Revision: 1.1 $
 */
public class JCAStatsImpl extends StatsImpl implements JCAStats {
    private JCAConnectionStats[] connectionStats;
    private JCAConnectionPoolStats[] connectionPoolStats;

    public JCAStatsImpl(JCAConnectionStats[] connectionStats, JCAConnectionPoolStats[] connectionPoolStats) {
        this.connectionStats = connectionStats;
        this.connectionPoolStats = connectionPoolStats;
    }

    public JCAConnectionStats[] getConnections() {
        return connectionStats;
    }

    public JCAConnectionPoolStats[] getConnectionPools() {
        return connectionPoolStats;
    }


}
