/** 
 * 
 * Copyright 2004 Hiram Chirino
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.service;

import org.codehaus.activemq.broker.Broker;

import java.io.Serializable;

/**
 * The TransactionTask interface should be implemented by any
 * class whose instances are intended to be executed as part
 * of a transaction event.  The class must define a method of
 * no arguments called execute.
 *
 * @version $Revision: 1.1 $
 */
public interface TransactionTask extends Serializable {

    public void execute(Broker broker) throws Throwable;
}
