/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.service.impl;

import org.codehaus.activemq.broker.Broker;
import org.codehaus.activemq.broker.BrokerClient;
import org.codehaus.activemq.message.MessageAck;

/**
 * Acknowledge a message as part of XA
 *
 * @version $Revision: 1.1 $
 */
public class MessageAckTransactionTask extends PacketTransactionTask {

    public MessageAckTransactionTask(BrokerClient brokerClient, MessageAck ack) {
        super(brokerClient, ack);
    }

    public void execute(Broker broker) throws Throwable {
        MessageAck ack = (MessageAck) getPacket();
        broker.acknowledgeMessage(getBrokerClient(ack.getConsumerId()), ack);
    }

}
