/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.service.impl;

import org.codehaus.activemq.service.QueueMessageContainer;
import org.codehaus.activemq.service.TopicMessageContainer;
import org.codehaus.activemq.store.PersistenceAdapter;

import javax.jms.JMSException;

/**
 * Abstract base class useful for implementation inheritence
 *
 * @version $Revision: 1.1 $
 */
public abstract class PersistenceAdapterSupport implements PersistenceAdapter {

    public TopicMessageContainer createTopicMessageContainer(String destinationName) throws JMSException {
        return new DurableTopicMessageContainer(createTopicMessageStore(destinationName), destinationName);
    }

    public QueueMessageContainer createQueueMessageContainer(String destinationName) throws JMSException {
        return new DurableQueueMessageContainer(this, createQueueMessageStore(destinationName), destinationName);
    }
}
