/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport;

import org.codehaus.activemq.service.Service;

import javax.jms.JMSException;
import java.util.Map;

/**
 * An agent used to discover other instances of a service
 *
 * @version $Revision: 1.2 $
 */
public interface DiscoveryAgent extends Service {

    /**
     * Add a discovery listener
     * @param listener
     */
    public void addDiscoveryListener(DiscoveryListener listener);
    
    /**
     * remove a discovery listener
     * @param listener
     */
    public void removeDiscoveryListener(DiscoveryListener listener);

    /**
     * register a service
     * @param name
     * @param details
     * @throws JMSException
     */
    void registerService(String name, Map details) throws JMSException;
}
