/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/

package org.codehaus.activemq.transport;


/**
 * Used by a server to listen for new clients coming and going
 * and reacting accordingly
 */

public interface TransportChannelListener {

    /**
     * Called when a new channel is added to a server
     *
     * @param channel the new channel
     */
    public void addClient(TransportChannel channel);

    /**
     * Called when a channel has been closed and removed from a server
     *
     * @param channel the channel removed
     */
    public void removeClient(TransportChannel channel);


}
