/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.multicast;

import EDU.oswego.cs.dl.util.concurrent.SynchronizedBoolean;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.codehaus.activemq.io.WireFormat;
import org.codehaus.activemq.transport.TransportServerChannelSupport;

import javax.jms.JMSException;
import java.net.URI;

/**
 * A Multicast implementation of TransportServerChannel
 *
 * @version $Revision: 1.2 $
 */
public class MulticastTransportServerChannel extends TransportServerChannelSupport {

    private static final Log log = LogFactory.getLog(MulticastTransportServerChannel.class);

    protected URI bindAddress;
    private SynchronizedBoolean started;

    public MulticastTransportServerChannel(WireFormat wireFormat, URI bindAddr) {
        super(bindAddr);
        this.bindAddress = bindAddr;
        started = new SynchronizedBoolean(false);
        log.info("ServerChannel at: " + bindAddress);
    }


    /**
     * start listeneing for events
     *
     * @throws JMSException if an error occurs
     */
    public void start() throws JMSException {
        if (started.commit(false, true)) {
        }
    }

    /**
     * @return pretty print of this
     */
    public String toString() {
        return "MulticastTransportServerChannel@" + bindAddress;
    }
}