/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.util;

import java.io.Serializable;
import java.util.Comparator;

/**
 * A trivial default {@link Comparator} which only works on objects
 * which are {@link Comparable}
 *
 * @version $Revision: 1.1 $
 */
public class DefaultComparator implements Comparator, Serializable {
    final static long serialVersionUID = 1L;

    public int compare(Object o1, Object o2) {
        Comparable c1 = (Comparable) o1;
        return c1.compareTo(o2);
    }
}
