/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.test;

import javax.jms.JMSException;

import org.codehaus.activemq.store.PersistenceAdapter;
import org.codehaus.activemq.util.Callback;
import org.codehaus.activemq.util.TransactionTemplate;

/**
 * @version $Revision: 1.1 $
 */
public class TimedTransactionTemplate extends TransactionTemplate {

    private int count;

    public TimedTransactionTemplate(PersistenceAdapter persistenceAdapter, int count) {
        super(persistenceAdapter);
        this.count = count;
    }

    public void run(Callback task) throws JMSException {
        long start = System.currentTimeMillis();

        super.run(task);

        long end = System.currentTimeMillis() - start;

        double average = end;
        average /= count;

        System.out.println("Completed in: " + end + " milli(s). Average: " + average + " milli(s)");
    }
}
