/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.multicast;

import org.codehaus.activemq.ActiveMQConnectionFactory;

/**
 * @version $Revision: 1.3 $
 */
public class DummyConnectionFactory extends ActiveMQConnectionFactory {
    public DummyConnectionFactory() {
    }

    public DummyConnectionFactory(String brokerURL) {
        super(brokerURL);
    }

    public DummyConnectionFactory(String userName, String password, String brokerURL) {
        super(userName, password, brokerURL);
    }

    protected String createMulticastClientID() {
        return getClientID() + "Multicaster";
    }

    /**
     * Unregisters the singleton broker so that we can test multiple brokers in the same VM
     */
    public void unregisterBroker() {
        unregisterBroker(getBrokerURL());
        brokerContainer = null;
    }
}
