/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.reliable;

import junit.textui.TestRunner;
import org.codehaus.activemq.transport.TransportChannelProvider;
import org.codehaus.activemq.transport.TransportChannelTestSupport;
import org.codehaus.activemq.transport.TransportServerChannelProvider;

import java.net.URI;

/**
 * @version $Revision: 1.1 $
 */
public class ReliableTransportChannelTest extends TransportChannelTestSupport {

    public static void main(String[] args) {
        TestRunner.run(ReliableTransportChannelTest.class);
    }

    public ReliableTransportChannelTest(String name) {
        super(name);
    }

    protected void setUp() throws Exception {
        URI uri = new URI("tcp://localhost:61617");
        server = TransportServerChannelProvider.create(wireFormat, uri);
        configureServer();
        uri = new URI(getCompositeURL());
        sender = TransportChannelProvider.create(wireFormat, uri);
        super.setUp();
    }

    protected String getCompositeURL() {
        return "reliable:tcp://localhost:61617";
    }

}