/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.spring;

import org.springframework.beans.BeansException;
import org.springframework.core.io.Resource;

/**
 * An exception that is thrown if a configuration resource could not
 * be parsed.
 *
 * @version $Revision: 1.1 $
 */
public class ConfigurationParseException extends BeansException {
    private Resource resource;

    public ConfigurationParseException(Resource resource, Throwable e) {
        super("Could not parse resource: " + resource + ". Reason: " + e, e);
        this.resource = resource;
    }

    /**
     * @return the resource that was being parsed when the exception ocurred
     */
    public Resource getResource() {
        return resource;
    }
}
