/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.tool;
import org.mortbay.http.SocketListener;
import org.mortbay.jetty.Server;

/**
 * @version $Revision: 1.1 $
 */
public class WebServer {
    public static final int PORT = 8080;
    //public static final String WEBAPP_DIR = "target/activemq";
    public static final String WEBAPP_DIR = "src/webapp";
    public static final String WEBAPP_CTX = "/";

    public static void main(String[] args) throws Exception {
        Server server = new Server();
        SocketListener listener = new SocketListener();
        listener.setPort(PORT);
        
        String webappDir = WEBAPP_DIR;
        if( args.length > 0 ) {
        	webappDir = args[0];
        }
        
        server.addWebApplication(WEBAPP_CTX, webappDir);
        server.addListener(listener);
        server.start();

    }
}
