/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.store.bdb;

import com.sleepycat.bind.EntityBinding;
import com.sleepycat.je.DatabaseEntry;

/**
 * @version $Revision: 1.1 $
 */
public class StringEntityBinding implements EntityBinding {
    public void objectToKey(Object element, DatabaseEntry entry) {
        String text = (String) element;
        entry.setData(text.getBytes());
    }

    public void objectToData(Object element, DatabaseEntry entry) {
        String text = (String) element;
        entry.setData(text.getBytes());
    }

    public Object entryToObject(DatabaseEntry key, DatabaseEntry value) {
        return new String(value.getData());
    }
}
