/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.store.jdbc;

import junit.framework.TestCase;
import org.axiondb.jdbc.AxionDataSource;
import org.codehaus.activemq.io.impl.DefaultWireFormat;
import org.codehaus.activemq.store.PersistenceAdapter;
import org.codehaus.activemq.store.PreparedTransactionStore;

import javax.jms.JMSException;

/**
 * @version $Revision: 1.2 $
 */
public class PersistenceAdapterTest extends TestCase {
    private PersistenceAdapter persistenceAdapter;
    private PreparedTransactionStore preparedTransactionStore;


    public void testStartAndStop() throws Exception {
        if (persistenceAdapter == null) {
            persistenceAdapter = createPersistenceAdapter();
        }
        persistenceAdapter.start();

        preparedTransactionStore = persistenceAdapter.createPreparedTransactionStore();
        preparedTransactionStore.start();


        // now lets shut down
        preparedTransactionStore.stop();
        persistenceAdapter.stop();
    }


    private PersistenceAdapter createPersistenceAdapter() throws JMSException {
        return createDefault();
    }

    /**
     * @return
     */
    public static PersistenceAdapter createDefault() {
        AxionDataSource ds = new AxionDataSource("jdbc:axiondb:testdb");
        return new JDBCPersistenceAdapter(ds, new DefaultWireFormat());
    }
}