/**
 *
 * Copyright 2004 Hiram Chirino
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 **/
package org.codehaus.activemq.journal;

/**
 * Exception thrown by a Journal to indicate that an invalid RecordLocation was detected.
 * 
 * @version $Revision: 1.1 $
 */
public class InvalidRecordLocationException extends Exception {

	/**
	 * 
	 */
	public InvalidRecordLocationException() {
		super();
	}

	/**
	 * @param msg
	 */
	public InvalidRecordLocationException(String msg) {
		super(msg);
	}

	/**
	 * @param msg
	 * @param rootCause
	 */
	public InvalidRecordLocationException(String msg, Throwable rootCause) {
		super(msg, rootCause);
	}
	
	/**
	 * @param rootCause
	 */
	public InvalidRecordLocationException(Throwable rootCause) {
		super(rootCause);
	}
}
