/**
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.jgroups;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.codehaus.activemq.transport.TransportServerChannelSupport;

import java.net.URI;

/**
 * A JGroups implementation of TransportServerChannel
 *
 * @version $Revision: 1.1 $
 */
public class JGroupsTransportServerChannel extends TransportServerChannelSupport {

    private static final Log log = LogFactory.getLog(JGroupsTransportServerChannel.class);

    public JGroupsTransportServerChannel(URI bindAddr) {
        super(bindAddr);
    }

    public String toString() {
        return "JGroupsTransportServerChannel@" + getUrl();
    }

}