/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.jgroups;

import junit.textui.TestRunner;
import org.codehaus.activemq.transport.TransportChannelTestSupport;

/**
 * @version $Revision: 1.1 $
 */
public class JGroupsTransportChannelWithCustomConfigTest extends TransportChannelTestSupport {

    public static final String config = "jgroups:UDP(mcast_addr=228.10.9.8;mcast_port=5678):PING:FD:GMS";

    /*
    public static final String config = "jgroups:" +
            "UDP(mcast_addr=228.8.8.8;mcast_port=45566;ip_ttl=32;" +
            "mcast_send_buf_size=64000;mcast_recv_buf_size=64000):" +
            //"PIGGYBACK(max_wait_time=100;max_size=32000):" +
            "PING(timeout=2000;num_initial_members=3):" +
            "MERGE2(min_interval=5000;max_interval=10000):" +
            "FD_SOCK:" +
            "VERIFY_SUSPECT(timeout=1500):" +
            "pbcast.NAKACK(max_xmit_size=8096;gc_lag=50;retransmit_timeout=600,1200,2400,4800):" +
            "UNICAST(timeout=600,1200,2400,4800):" +
            "pbcast.STABLE(desired_avg_gossip=20000):" +
            "FRAG(frag_size=8096;down_thread=false;up_thread=false):" +
            // "CAUSAL:" +
            "pbcast.GMS(join_timeout=5000;join_retry_timeout=2000;" +
            "shun=false;print_local_addr=true)";
    */

    public static void main(String[] args) {
        TestRunner.run(JGroupsTransportChannelWithCustomConfigTest.class);
    }

    public JGroupsTransportChannelWithCustomConfigTest(String name) {
        super(name);
    }

    protected void setUp() throws Exception {
        createSenderAndReceiver(config);
        super.setUp();
    }

}