/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.transport.xstream;

import org.codehaus.activemq.io.WireFormat;
import org.codehaus.activemq.message.ActiveMQMessage;
import org.codehaus.activemq.test.WireFormatTestSupport;

/**
 * @version $Revision: 1.3 $
 */
public class XStreamWireFormatTest extends WireFormatTestSupport {

    public void testViewXStreamXML() throws Exception {
        writeMessageAsXml(createMessage());
        writeMessageAsXml(createObjectMessage());
        writeMessageAsXml(createMapMessage());
    }

    protected void writeMessageAsXml(ActiveMQMessage message) {
        String xml = getXStreamWireFormat().toString(message);
        System.out.println(message.getClass().getName() + " as XML is:");
        System.out.println(xml);
    }

    protected XStreamWireFormat getXStreamWireFormat() {
        return (XStreamWireFormat) wireFormat;
    }

    protected WireFormat createWireFormat() {
        return new XStreamWireFormat();
    }
}
